# CommandCost Class Reference

Common return value for all commands. More...

`#include <command_type.h>`

## Public Member Functions
| CommandCost ()
| Creates a command cost return with no cost and no error.
| CommandCost (StringID msg)
| Creates a command return value the is failed with the given message.
| CommandCost (ExpensesType ex_t)
| Creates a command cost with given expense type and start cost of 0.
| CommandCost (ExpensesType ex_t, Money cst)
| Creates a command return value with the given start cost and expense type.
CommandCost | AddCost (CommandCost ret)
| Adds the cost of the given command return value to this cost.
CommandCost | AddCost (Money cost)
| Adds the given cost to the cost of the command.
CommandCost | MultiplyCost (int factor)
| Multiplies the cost of the command by the given factor.
Money | GetCost () const
| The costs as made up to this moment.
ExpensesType | GetExpensesType () const
| The expense type of the cost.
void | SetGlobalErrorMessage () const
| Sets the global error message *if* this class has one.
StringID | GetErrorMessage () const
| Returns the error message of a command.
bool | Succeeded () const
| Did this command succeed?
bool | Failed () const
| Did this command fail?
## Private Attributes
ExpensesType | expense_type
| the type of expence as shown on the finances view
Money | cost
| The cost of this action.
StringID | message
| Warning message for when success is unset.
bool | success
| Whether the comment went fine up to this moment.

## Detailed Description

Common return value for all commands.

Wraps the cost and a possible error message/state together.

Definition at line 16 of file command_type.h.

## Constructor & Destructor Documentation

CommandCost::CommandCost | ( | ExpensesType | ex_t | ) | `[inline]`

Creates a command cost with given expense type and start cost of 0.

Parameters:

  | ex_t | the expense type

Definition at line 37 of file command_type.h.

CommandCost::CommandCost | ( | ExpensesType | ex_t,
|  | Money | cst |
| ) |  |  | `[inline]`

Creates a command return value with the given start cost and expense type.

Parameters:

  | ex_t | the expense type
  | cst | the initial cost of this command

Definition at line 44 of file command_type.h.

## Member Function Documentation

CommandCost CommandCost::AddCost | ( | CommandCost | ret | ) |

Adds the cost of the given command return value to this cost.

Also takes a possible error message when it is set.

Parameters:

  | ret | the command to add the cost of.

Returns:
  this class.

Definition at line 649 of file command.cpp.

References cost, message, and success.

Referenced by BuildReplacementVehicle(), CheckFlatLandBelow(), CmdAutoreplaceVehicle(), CmdBuildAirport(), CmdBuildBridge(), CmdBuildCanal(), CmdBuildCompanyHQ(), CmdBuildLongRoad(), CmdBuildRoad(), CmdBuildRoadDepot(), CmdBuildRoadStop(), CmdBuildSingleRail(), CmdBuildTrainDepot(), CmdBuildTunnel(), CmdBuyShareInCompany(), CmdClearArea(), CmdCloneVehicle(), CmdConvertRail(), CmdDepotMassAutoReplace(), CmdDepotSellAllVehicles(), CmdLevelLand(), CmdPlantTree(), CmdPurchaseLandArea(), CmdRailTrackHelper(), CmdRefitRailVehicle(), CmdRefitRoadVeh(), CmdRemoveLongRoad(), CmdRemoveSingleRail(), CmdSellRailWagon(), CmdSignalTrackHelper(), CmdTerraformLand(), CopyHeadSpecificThings(), AIObject::IncreaseDoCommandCosts(), RemoveRoad(), ReplaceFreeUnit(), TerraformTileHeight(), and TestAutoslopeOnRailTile().

CommandCost CommandCost::AddCost | ( | Money | cost | ) | `[inline]`

Adds the given cost to the cost of the command.

Parameters:

  | cost | the cost to add

Returns:
  this class.

Definition at line 59 of file command_type.h.

CommandCost CommandCost::MultiplyCost | ( | int | factor | ) | `[inline]`

Multiplies the cost of the command by the given factor.

Parameters:

  | factor | factor to multiply the costs with

Returns:
  this class

Definition at line 70 of file command_type.h.

References cost.

Referenced by CmdBuildRoad().

Money CommandCost::GetCost | ( |  | ) | const`[inline]`

The costs as made up to this moment.

Returns:
  the costs

Definition at line 80 of file command_type.h.

References cost.

Referenced by CmdAutoreplaceVehicle(), CmdBuildBridge(), CmdBuildCanal(), CmdBuildRailroadStation(), CmdBuildRoad(), CmdBuildTunnel(), CmdClearArea(), CmdConvertRail(), CmdDepotSellAllVehicles(), CmdGiveMoney(), CmdLevelLand(), CmdPlantTree(), CmdRailTrackHelper(), CmdRemoveLongRoad(), DoCommand(), AIObject::DoCommand(), DoCommandP(), AIObject::GetDoCommandCosts(), ReplaceChain(), and ShowBuildBridgeWindow().

ExpensesType CommandCost::GetExpensesType | ( |  | ) | const`[inline]`

The expense type of the cost.

Returns:
  the expense type

Definition at line 89 of file command_type.h.

References expense_type.

StringID CommandCost::GetErrorMessage | ( |  | ) | const`[inline]`

Returns the error message of a command.

Returns:
  the error message, if succeeded INVALID_STRING_ID

Definition at line 107 of file command_type.h.

References INVALID_STRING_ID, message, and success.

Referenced by CmdDepotMassAutoReplace().

bool CommandCost::Succeeded | ( |  | ) | const`[inline]`

Did this command succeed?

Returns:
  true if and only if it succeeded

Definition at line 120 of file command_type.h.

References success.

Referenced by BuildReplacementVehicle(), CmdAutoreplaceVehicle(), CmdSucceeded(), CopyHeadSpecificThings(), ReplaceChain(), and ReplaceFreeUnit().

bool CommandCost::Failed | ( |  | ) | const`[inline]`

Did this command fail?

Returns:
  true if and only if it failed

Definition at line 129 of file command_type.h.

References success.

Referenced by BuildReplacementVehicle(), CmdAutoreplaceVehicle(), CmdFailed(), and CmdSellRailWagon().

The documentation for this class was generated from the following files:

- src/command_type.h
- src/command.cpp